'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('babel-polyfill');

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

var _mongodb = require('mongodb');

var _mongodbUri = require('mongodb-uri');

var _mongodbUri2 = _interopRequireDefault(_mongodbUri);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_MONGO_URI = _mongodbUri2.default.format({
  scheme: 'mongodb',
  hosts: [{ host: 'localhost', port: 27017 }],
  database: 'local',
  options: {
    readPreference: 'secondaryPreferred'
  }
});

var OpLogger = function (_EventEmitter) {
  _inherits(OpLogger, _EventEmitter);

  function OpLogger(mongodbUri) {
    _classCallCheck(this, OpLogger);

    var _this = _possibleConstructorReturn(this, (OpLogger.__proto__ || Object.getPrototypeOf(OpLogger)).call(this));

    _this.mongodbUri = mongodbUri;
    _this.handleOp = _this.handleOp.bind(_this);
    _this.handleError = _this.handleError.bind(_this);
    _this.tail = _this.tail.bind(_this);
    return _this;
  }

  _createClass(OpLogger, [{
    key: 'getUri',
    value: function getUri() {
      if (this.mongodbUri) {
        var parsed = _mongodbUri2.default.parse(this.mongodbUri);
        parsed.database = 'local';
        return _mongodbUri2.default.format(parsed);
      }
      return DEFAULT_MONGO_URI;
    }
  }, {
    key: 'getDb',
    value: function getDb() {
      var _this2 = this;

      var connectUri = this.getUri();
      return _mongodb.MongoClient.connect(connectUri).then(function (db) {
        _this2.db = db;
        return Promise.resolve(db);
      }).catch(this.handleError);
    }
  }, {
    key: 'tail',
    value: function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(timestamp) {
        var tsNow, ts, db, collection, cursor, stream;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                tsNow = (0, _mongodb.Timestamp)(0, new Date() / 1000);
                ts = timestamp || tsNow;
                _context.t0 = this.db;

                if (_context.t0) {
                  _context.next = 7;
                  break;
                }

                _context.next = 6;
                return this.getDb();

              case 6:
                _context.t0 = _context.sent;

              case 7:
                db = _context.t0;
                collection = db.collection('oplog.rs');
                cursor = collection.find({ ts: { '$gte': ts } }, {
                  tailable: true,
                  awaitdata: true
                });
                stream = cursor.stream();

                this.stream = stream;
                stream.on('data', this.handleOp);
                stream.on('error', this.handleError);

              case 14:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function tail(_x) {
        return _ref.apply(this, arguments);
      }

      return tail;
    }()
  }, {
    key: 'handleError',
    value: function handleError(error) {
      this.emit('error', error);
    }
  }, {
    key: 'handleOp',
    value: function handleOp(op) {
      this.emit('op', op);

      var opType = OpLogger.opMap[op.op];
      if (opType) {
        this.emit(opType, op);
      }
    }
  }]);

  return OpLogger;
}(_events2.default);

OpLogger.opMap = {
  n: 'no-op', // does not result in a change to data
  i: 'insert', // insert new doc
  u: 'update', // update existing doc
  d: 'delete', // delete existing doc
  c: 'command', // used for communicating commands performed on dbs
  db: 'database' };
exports.default = OpLogger;